"use strict";

const simpleSource = require("@ppstreams/simple-source");
const EndOfStream = require("@ppstreams/end-of-stream");

module.exports = function rangeNumbers(start, end, step = 1) {
	/* End is exclusive */
	let i = start;

	return simpleSource({
		onRequest: () => {
			if (i >= end) {
				throw new EndOfStream();
			} else {
				let number = i;
				i += step;
				return number;
			}
		}
	});
};
